import * as OSS from 'ali-oss';
import { memoize } from 'lodash';

const client = new OSS({
  region: 'oss-cn-hangzhou',
  accessKeyId: 'LTAI4G2BEDNpfdLmquYYMaMV',
  accessKeySecret: 'tPhAL3qAgF9Tq67h73snAmwu8iPZ5t',
  bucket: 'yiyun-client-files',
  secure: true,
});
/**
 * 存储逻辑
 *  + oss上的存储文件路径为 时间戳 / 文件名
 *  + 文件路径信息保存到服务器端时，添加拟协议头 oss://
*  + 示例：
 *      文件名为oss.js
 *      则在oss上保存的路径为 1601016877378/oss.js
 *      在服务器上存储的记录为: oss://1601016877378/oss.js
 */

const generateStoreKey = (name: string) => `${new Date().getTime()}/${name}`;

export const wrapOssProtocol = (path: string) => `oss://${path}`;

export async function multipartUpload(fileName: string, file: any, opt: OSS.MultipartUploadOptions = {}) {
  try {
    const storeAs = generateStoreKey(fileName);
    const result = await client.multipartUpload(storeAs, file, opt);
    return result;
  } catch (ex) {
    console.error('file upload failed:', ex);
    return null;
  }
}
/**
 * 
 * @param {*} objectKey 文件在服务器上的path值，格式为: oss://${timestamp}/filename 
 * @param {*} saveAs 
 */
export const getFileUrl = memoize(function getFileUrlInner(serverOSSPath = '', saveAs?: string) {
  if (serverOSSPath.indexOf('oss://') !== 0) {
    return serverOSSPath;
  }
  const objectKey = serverOSSPath.substr(6);
  const filename = saveAs || objectKey.split('/').pop();
  try {
    const expires = 3600;
    const result = client.signatureUrl(objectKey, {
      expires,
      response: {
        'content-disposition': `attachment; filename="${filename}"`,
      },
    });
    setTimeout(() => {
      getFileUrl.cache.delete(serverOSSPath);
    }, expires * 1000)
    return result;
  } catch (ex) {
    return null;
  }
})